// EPCDemoView.cpp : implementation of the CEPCDemoView class
//

#include "stdafx.h"
#include "EPCDemo.h"

#include "EPCDemoDoc.h"
#include "EPCDemoView.h"
#include "EPCSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEPCDemoView

IMPLEMENT_DYNCREATE(CEPCDemoView, CFormView)

BEGIN_MESSAGE_MAP(CEPCDemoView, CFormView)
	//{{AFX_MSG_MAP(CEPCDemoView)
	ON_BN_CLICKED(IDC_BUTTON_Connect, OnBUTTONConnect)
	ON_BN_CLICKED(IDC_BUTTON_Disconnect, OnBUTTONDisconnect)
	ON_BN_CLICKED(IDC_BUTTON_Clear, OnBUTTONClear)
	ON_BN_CLICKED(IDC_BUTTON_Start, OnBUTTONStart)
	ON_BN_CLICKED(IDC_BUTTON_Stop, OnBUTTONStop)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

int		CEPCDemoView::m_tagIDNum = 0;
STagID	CEPCDemoView::m_tagIDs[NUM_MaxTag];

/////////////////////////////////////////////////////////////////////////////
// CEPCDemoView construction/destruction
CEPCDemoView::CEPCDemoView()
	: CFormView(CEPCDemoView::IDD)
{
	//{{AFX_DATA_INIT(CEPCDemoView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_hCom = INVALID_HANDLE_VALUE;
	m_status = STATUS_Init;
}

CEPCDemoView::~CEPCDemoView()
{
}

void CEPCDemoView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEPCDemoView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BOOL CEPCDemoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CEPCDemoView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
	// Init
	Initialize();
	SetStatus(STATUS_Init);
}

void CEPCDemoView::Initialize(void)
{
	CComboBox* comboPortNo = (CComboBox*)GetDlgItem(IDC_COMBO_PortNo);
	CComboBox* comboBaudRate = (CComboBox*)GetDlgItem(IDC_COMBO_BaudRate);
	CButton* checkSave = (CButton*)GetDlgItem(IDC_CHECK_SAVE);
	comboPortNo->SetCurSel(0);
	comboBaudRate->SetCurSel(0);
	checkSave->SetCheck(1);
}

void CEPCDemoView::Finalize(void)
{
	KillTimer(TIMER_ReadTag);
	if(m_hCom != INVALID_HANDLE_VALUE)
	{
		::ResetReader(m_hCom,0);
		::CloseComm(m_hCom);
		m_hCom = INVALID_HANDLE_VALUE;
	}
}

void CEPCDemoView::SetStatus(int status)
{
	CComboBox* comboPortNo = (CComboBox*)GetDlgItem(IDC_COMBO_PortNo);
	CComboBox* comboBaudRate = (CComboBox*)GetDlgItem(IDC_COMBO_BaudRate);
	CButton* btnConnect = (CButton*)GetDlgItem(IDC_BUTTON_Connect);
	CButton* btnDisconnect = (CButton*)GetDlgItem(IDC_BUTTON_Disconnect);
	CButton* btnStart = (CButton*)GetDlgItem(IDC_BUTTON_Start);
	CButton* btnStop = (CButton*)GetDlgItem(IDC_BUTTON_Stop);
	CButton* checkSave = (CButton*)GetDlgItem(IDC_CHECK_SAVE);
	
	if(status == STATUS_Init)
	{
		comboPortNo->EnableWindow(TRUE);
		comboBaudRate->EnableWindow(TRUE);
		btnConnect->EnableWindow(TRUE);
		btnDisconnect->EnableWindow(FALSE);
		checkSave->EnableWindow(FALSE);
		btnStart->EnableWindow(FALSE);
		btnStop->EnableWindow(FALSE);
	}
	else if(status == STATUS_CommOpen)
	{
		comboPortNo->EnableWindow(FALSE);
		comboBaudRate->EnableWindow(FALSE);
		btnConnect->EnableWindow(FALSE);
		btnDisconnect->EnableWindow(TRUE);
		checkSave->EnableWindow(TRUE);
		btnStart->EnableWindow(TRUE);
		btnStop->EnableWindow(FALSE);
	}
	else if(status == STATUS_ReadingTag)
	{
		comboPortNo->EnableWindow(FALSE);
		comboBaudRate->EnableWindow(FALSE);
		btnConnect->EnableWindow(FALSE);
		btnDisconnect->EnableWindow(FALSE);
		checkSave->EnableWindow(FALSE);
		btnStart->EnableWindow(FALSE);
		btnStop->EnableWindow(TRUE);
	}
	else
		ASSERT(FALSE);
}

int	CEPCDemoView::GetStatus(void)
{
	return m_status;
}

void CEPCDemoView::DisplayInNewLine(UINT strID)
{
	CString str;
	str.LoadString(strID);
	DisplayInNewLine((LPCTSTR)str);
}

void CEPCDemoView::DisplayInNewLine(LPCTSTR str)
{
	CEdit* editDisplay = (CEdit*)GetDlgItem(IDC_EDIT_Display);
	CString strDisplay;
	editDisplay->GetWindowText(strDisplay);
	if(strDisplay.GetLength() != 0)
		strDisplay += "\r\n";
	strDisplay += str;
	editDisplay->SetWindowText((LPCTSTR)strDisplay);
	editDisplay->SetSel(strDisplay.GetLength(), strDisplay.GetLength());
}

void CEPCDemoView::Display(UINT strID)
{
	CString str;
	str.LoadString(strID);
	Display((LPCTSTR)str);
}

void CEPCDemoView::Display(LPCTSTR str)
{
	CEdit* editDisplay = (CEdit*)GetDlgItem(IDC_EDIT_Display);
	CString strDisplay;
	editDisplay->GetWindowText(strDisplay);
	if(strDisplay.GetLength() != 0)
		strDisplay += " ";
	strDisplay += str;
	editDisplay->SetWindowText((LPCTSTR)strDisplay);
	editDisplay->SetSel(strDisplay.GetLength(), strDisplay.GetLength());
}

void CEPCDemoView::ReadTagProcess(void)
{
	BYTE tagID[LEN_TagID];
    BYTE* devNo=NULL;
	BYTE* antennaNo=NULL;
	if(::IdentifyUploadedSingleTag(m_hCom, tagID,devNo,antennaNo))
	{
		time_t curTime = ::time(NULL);
//		if(IsNewTag(tagID))
		{
			if(m_tagIDNum < NUM_MaxTag)
			{
				// Add
				::memcpy(m_tagIDs[m_tagIDNum].tagID, tagID, LEN_TagID);
				m_tagIDs[m_tagIDNum].time = curTime;
				m_tagIDNum++;
				// Display
//				CString strTagIDDecimal;
//				GetTagIDDecStr(tagID, &strTagIDDecimal);
//				DisplayInNewLine(strTagIDDecimal);

				CString strTagIDHex;
				CString strTime;
				GetTagIDHexStr(tagID, &strTagIDHex);
				GetTimeStr(curTime, &strTime);
				DisplayInNewLine(strTagIDHex + "  " + strTime);
			}
			else
				DisplayInNewLine(IDS_MSG_MaxTagIDNum);
		}
	}
}

void CEPCDemoView::SaveTagsToFile(LPCTSTR path)
{
	CStdioFile file;
	if(file.Open(path, CFile::modeCreate | CFile::modeReadWrite | CFile::typeText, NULL))
	{
		for(int i = 0; i < m_tagIDNum; i++)
		{
		//	CString tagIDDecimalStr;
		//	GetTagIDDecStr(m_tagIDs[i].tagID, &tagIDDecimalStr);
		//	file.WriteString(tagIDDecimalStr + "\r\n");
			CString strTagIDHex;
			CString strTime;
			GetTagIDHexStr(m_tagIDs[i].tagID, &strTagIDHex);
			GetTimeStr(m_tagIDs[i].time, &strTime);
			file.WriteString(strTagIDHex + "  " + strTime + "\r\n");
		}
		file.Close();
	}
}

bool CEPCDemoView::IsNewTag(BYTE tagID[LEN_TagID])
{
	bool ret = true;
	for(int i = 0; i < m_tagIDNum; i++)
	{
		if(::memcmp(tagID, &m_tagIDs[i], LEN_TagID) == 0)
		{
			ret = false;
			break;
		}
	}
	return ret;
}

void CEPCDemoView::GetTagIDDecStr(const BYTE tagID[LEN_TagID], CString* str)
{
	long tagIDDecimal = 0;
	for(int i = LEN_TagID - LEN_TagIDUseful; i < LEN_TagID; i++)
		tagIDDecimal = tagIDDecimal * 256 + tagID[i];
	str->Format("%08d", tagIDDecimal);
}

void CEPCDemoView::GetTagIDHexStr(const BYTE tagID[LEN_TagID], CString* str)
{
	str->Empty();
	CString tmp;
	for(int i = 0; i < LEN_TagID; i++)
	{
		tmp.Format("%02X ", tagID[i]);
		*str += tmp;
	}
}

void CEPCDemoView::GetTimeStr(time_t time, CString* str)
{
	CTime t(time);
	str->Format("%04d/%02d/%02d %02d:%02d:%02d", t.GetYear(), t.GetMonth(), t.GetDay(), 
		t.GetHour(), t.GetMinute(), t.GetSecond());
}

void CEPCDemoView::MakeToSaveFilePathByTime(CString* fullPath, CString* fileName)
{
	// Module Directory
	CString moduleDir;
	GetModuleDir(&moduleDir);
	// File Name
	CTime curTime(::time(NULL));
	CString toSaveFileName;
	toSaveFileName.Format("TagIDs_%04d%02d%02d_%02d%02d%02d.txt", 
		curTime.GetYear(), curTime.GetMonth(), curTime.GetDay(),
		curTime.GetHour(), curTime.GetMinute(), curTime.GetSecond());
	*fullPath = moduleDir + toSaveFileName;
	*fileName = toSaveFileName;
}

void CEPCDemoView::GetModuleDir(CString* path)
{
	char drv[_MAX_DRIVE], dir[_MAX_DIR], fileName[_MAX_FNAME], ext[_MAX_EXT];
	char modulePath[_MAX_PATH], moduleDir[_MAX_PATH];
	::GetModuleFileName(NULL, modulePath, _MAX_PATH);
	_splitpath(modulePath, drv, dir, fileName, ext);
	_makepath(moduleDir, drv, dir, NULL, NULL);
	*path = moduleDir;
}

bool CEPCDemoView::IsHexChar(char ch)
{
	if(	ch == 'a' || ch == 'b' || ch == 'c' || ch == 'd' || ch == 'e' || ch == 'f' ||
		ch == 'A' || ch == 'B' || ch == 'C' || ch == 'D' || ch == 'E' || ch == 'F' ||
		ch == '0' || ch == '1' || ch == '2' || ch == '3' || ch == '4' || 
		ch == '5' || ch == '6' || ch == '7' || ch == '8' || ch == '9')
		return true;
	else
		return false;
}

bool CEPCDemoView::StrToHexNums(LPCTSTR str, BYTE* hexBuf, BYTE* len)
{
	CString strHex = str;
	strHex.Remove(' ');		// Remove all Spaces (0x20)
	int strLen = strHex.GetLength();
	if(strLen < 2 || (strLen % 2) != 0 || strLen > ((*len) * 2))
		return false;
	// Check if it is valid hex input
	const char* start = (LPCTSTR)strHex;
	for(int i = 0; i < strLen; i++)
	{
		if(!IsHexChar(*(start + i)))
			return false;
	}
	// Convert every two chars to a BYTE number
	char tmpBuf[3] = {'\0', '\0', '\0'};
	char* endptr = NULL;
	::memset(hexBuf, 0, sizeof(BYTE) * (*len));
	for(int j = 0; j < strLen / 2; j++)
	{
		::memcpy(tmpBuf, start + j * 2, 2);
		BYTE value = (BYTE)::strtol((LPCTSTR)tmpBuf, &endptr, 16);
		hexBuf[j] = value;
	}
	*len = strLen / 2;
	return true;
}

/////////////////////////////////////////////////////////////////////////////
// CEPCDemoView diagnostics

#ifdef _DEBUG
void CEPCDemoView::AssertValid() const
{
	CFormView::AssertValid();
}

void CEPCDemoView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CEPCDemoDoc* CEPCDemoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEPCDemoDoc)));
	return (CEPCDemoDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEPCDemoView message handlers

void CEPCDemoView::OnBUTTONConnect() 
{
	CComboBox* comboPortNo = (CComboBox*)GetDlgItem(IDC_COMBO_PortNo);
	int portNo = comboPortNo->GetCurSel() + 1;
	m_hCom = ::OpenComm(portNo);
	if(m_hCom != INVALID_HANDLE_VALUE)
	{
		int main = 0;
		int sub = 0;
		if(ReadFirmwareVersion(m_hCom, &main, &sub,0))
		{
			SetStatus(STATUS_CommOpen);
			CString strFormat;
			strFormat.LoadString(IDS_MSG_FirmVersion);
			CString strFirmVersion;
			strFirmVersion.Format(strFormat, main, sub);
			DisplayInNewLine(IDS_MSG_Connect);
			DisplayInNewLine(strFirmVersion);
		}
		else
		{
			CloseComm(m_hCom);
			DisplayInNewLine(IDS_MSG_ConnectDeviceFail);
		}
	}
	else
		DisplayInNewLine(IDS_MSG_OpenCommFail);
}

void CEPCDemoView::OnBUTTONDisconnect() 
{
	SetStatus(STATUS_Init);
	::ResetReader(m_hCom,0);
	::CloseComm(m_hCom);
	m_hCom = INVALID_HANDLE_VALUE;
	DisplayInNewLine(IDS_MSG_Disconnect);
}

void CEPCDemoView::OnBUTTONClear() 
{
	CEdit* display = (CEdit*)GetDlgItem(IDC_EDIT_Display);
	display->SetWindowText("");
}

void CEPCDemoView::OnBUTTONStart() 
{
	SetStatus(STATUS_ReadingTag);
	DisplayInNewLine("");	// Add Blank Line
	DisplayInNewLine(IDS_MSG_StartReadTag);
	SetTimer(TIMER_ReadTag, 100, NULL);
}

void CEPCDemoView::OnBUTTONStop() 
{
	SetStatus(STATUS_CommOpen);
	KillTimer(TIMER_ReadTag);
	CButton* checkSave = (CButton*)GetDlgItem(IDC_CHECK_SAVE);
	if(checkSave->GetCheck())
	{
		// Save
		CString fullPath;
		CString fileName;
		MakeToSaveFilePathByTime(&fullPath, &fileName);
		SaveTagsToFile(fullPath);
		// Display
		CString strFormat;
		strFormat.LoadString(IDS_MSG_StopReadTagWithSave);
		CString strMessage;
		strMessage.Format(strFormat, fileName);
		DisplayInNewLine(strMessage);
	}
	else
		DisplayInNewLine(IDS_MSG_StopReadTag);
	DisplayInNewLine("");	// Add Blank Line
	// Clear TagIDs
	m_tagIDNum = 0;
}

void CEPCDemoView::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == TIMER_ReadTag)
		ReadTagProcess();
	else
		CFormView::OnTimer(nIDEvent);
}

void CEPCDemoView::OnDestroy() 
{
	CFormView::OnDestroy();
	Finalize();
}
