// EPCDemoView.cpp : implementation of the CEPCDemoView class
//

#include "stdafx.h"
#include "EPCDemo.h"

#include "EPCDemoDoc.h"
#include "EPCDemoView.h"
#include "EPCSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEPCDemoView

IMPLEMENT_DYNCREATE(CEPCDemoView, CFormView)

BEGIN_MESSAGE_MAP(CEPCDemoView, CFormView)
	//{{AFX_MSG_MAP(CEPCDemoView)
	ON_BN_CLICKED(IDC_BUTTON_Connect, OnBUTTONConnect)
	ON_BN_CLICKED(IDC_BUTTON_Disconnect, OnBUTTONDisconnect)
	ON_BN_CLICKED(IDC_BUTTON_Clear, OnBUTTONClear)
	ON_BN_CLICKED(IDC_BUTTON_Start, OnBUTTONStart)
	ON_BN_CLICKED(IDC_BUTTON_Stop, OnBUTTONStop)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEPCDemoView construction/destruction

CEPCDemoView::CEPCDemoView()
	: CFormView(CEPCDemoView::IDD)
{
	//{{AFX_DATA_INIT(CEPCDemoView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_hCom = INVALID_HANDLE_VALUE;
	m_status = STATUS_Init;
	m_toWriteTagIDNum = 0;
	for(int i = 0; i < NUM_ToWriteTagIDBytesMax; i++)
		m_toWriteTagID[i] = 0;
	for(i = 0; i < LEN_TagID; i++)
		m_currentTagID[i] = 0;

	m_verMain = 0;
	m_verSub = 0;
}

CEPCDemoView::~CEPCDemoView()
{
}

void CEPCDemoView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEPCDemoView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BOOL CEPCDemoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CEPCDemoView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
	// Init
	Initialize();
	SetStatus(STATUS_Init);
}

void CEPCDemoView::Initialize(void)
{
	CComboBox* comboPortNo = (CComboBox*)GetDlgItem(IDC_COMBO_PortNo);
	CComboBox* comboBaudRate = (CComboBox*)GetDlgItem(IDC_COMBO_BaudRate);
	CEdit* editTagID = (CEdit*)GetDlgItem(IDC_EDIT_TAGID);
	CComboBox* comboSpeed = (CComboBox*)GetDlgItem(IDC_COMBO_Speed);
	comboPortNo->SetCurSel(0);
	comboBaudRate->SetCurSel(0);
	editTagID->SetWindowText("00 01");
	comboSpeed->SetCurSel(0);
}

void CEPCDemoView::Finalize(void)
{
	KillTimer(TIMER_WrittingTag);
	if(m_hCom != INVALID_HANDLE_VALUE)
	{
		::ResetReader(m_hCom,0);
		::CloseComm(m_hCom);
		m_hCom = INVALID_HANDLE_VALUE;
	}
}

void CEPCDemoView::SetStatus(int status)
{
	CComboBox* comboPortNo = (CComboBox*)GetDlgItem(IDC_COMBO_PortNo);
	CComboBox* comboBaudRate = (CComboBox*)GetDlgItem(IDC_COMBO_BaudRate);
	CButton* btnConnect = (CButton*)GetDlgItem(IDC_BUTTON_Connect);
	CButton* btnDisconnect = (CButton*)GetDlgItem(IDC_BUTTON_Disconnect);
	CButton* btnStart = (CButton*)GetDlgItem(IDC_BUTTON_Start);
	CButton* btnStop = (CButton*)GetDlgItem(IDC_BUTTON_Stop);
	CEdit* editTagID = (CEdit*)GetDlgItem(IDC_EDIT_TAGID);
	CButton* checkLock = (CButton*)GetDlgItem(IDC_CHECK_LOCK);
	CComboBox* comboSpeed = (CComboBox*)GetDlgItem(IDC_COMBO_Speed);
	
	if(status == STATUS_Init)
	{
		comboPortNo->EnableWindow(TRUE);
		comboBaudRate->EnableWindow(TRUE);
		btnConnect->EnableWindow(TRUE);
		btnDisconnect->EnableWindow(FALSE);
		editTagID->EnableWindow(FALSE);
		checkLock->EnableWindow(FALSE);
		comboSpeed->EnableWindow(FALSE);
		btnStart->EnableWindow(FALSE);
		btnStop->EnableWindow(FALSE);
	}
	else if(status == STATUS_CommOpen)
	{
		comboPortNo->EnableWindow(FALSE);
		comboBaudRate->EnableWindow(FALSE);
		btnConnect->EnableWindow(FALSE);
		btnDisconnect->EnableWindow(TRUE);
		editTagID->EnableWindow(TRUE);
		checkLock->EnableWindow(TRUE);
		comboSpeed->EnableWindow(TRUE);
		btnStart->EnableWindow(TRUE);
		btnStop->EnableWindow(FALSE);
	}
	else if(status == STATUS_WrittingTag)
	{
		comboPortNo->EnableWindow(FALSE);
		comboBaudRate->EnableWindow(FALSE);
		btnConnect->EnableWindow(FALSE);
		btnDisconnect->EnableWindow(FALSE);
		editTagID->EnableWindow(FALSE);
		checkLock->EnableWindow(FALSE);
		comboSpeed->EnableWindow(FALSE);
		btnStart->EnableWindow(FALSE);
		btnStop->EnableWindow(TRUE);
	}
	else
		ASSERT(FALSE);
}

int	CEPCDemoView::GetStatus(void)
{
	return m_status;
}

void CEPCDemoView::DisplayInNewLine(UINT strID)
{
	CString str;
	str.LoadString(strID);
	DisplayInNewLine((LPCTSTR)str);
}

void CEPCDemoView::DisplayInNewLine(LPCTSTR str)
{
	CEdit* editDisplay = (CEdit*)GetDlgItem(IDC_EDIT_Display);
	CString strDisplay;
	editDisplay->GetWindowText(strDisplay);
	if(strDisplay.GetLength() != 0)
		strDisplay += "\r\n";
	strDisplay += str;
	editDisplay->SetWindowText((LPCTSTR)strDisplay);
	editDisplay->SetSel(strDisplay.GetLength(), strDisplay.GetLength());
}

void CEPCDemoView::Display(UINT strID)
{
	CString str;
	str.LoadString(strID);
	Display((LPCTSTR)str);
}

void CEPCDemoView::Display(LPCTSTR str)
{
	CEdit* editDisplay = (CEdit*)GetDlgItem(IDC_EDIT_Display);
	CString strDisplay;
	editDisplay->GetWindowText(strDisplay);
	if(strDisplay.GetLength() != 0)
		strDisplay += " ";
	strDisplay += str;
	editDisplay->SetWindowText((LPCTSTR)strDisplay);
	editDisplay->SetSel(strDisplay.GetLength(), strDisplay.GetLength());
}

void CEPCDemoView::WriteTagProcess(void)
{
	BYTE tagID[LEN_TagID];
	if(::IdentifySingleTagSilently(m_hCom, tagID,0))
	{
		if(IsNewTag(tagID))
		{
			DisplayInNewLine(IDS_MSG_NewTag);
			bool authorized = true;
//>xxm 110321			if(m_verMain >= 2)
			if(m_verMain >= 6)  //<xxm 110321
				authorized = AuthorizeTag();
			if(authorized)
			{
				CButton* checkLock = (CButton*)GetDlgItem(IDC_CHECK_LOCK);
				bool lock = (checkLock->GetCheck() != 0);
				if(WriteTag(lock))
				{
					// Display Result in Operation List
					CString strFormat;
//>xxm 110321					if(m_verMain >= 2)
					if(m_verMain >= 4)  //<xxm 110321
						strFormat.LoadString(lock ? IDS_MSG_AuthoWriteLock : IDS_MSG_AuthoWrite);
					else
						strFormat.LoadString(lock ? IDS_MSG_WriteLock : IDS_MSG_Write);

					CString toWriteTagIDStr;
					GetToWriteTagIDStr(&toWriteTagIDStr);
					CString dispStr;
					dispStr.Format(strFormat, toWriteTagIDStr);
					DisplayInNewLine(dispStr);

					SetCurrentTagID(tagID, m_toWriteTagIDNum, &m_toWriteTagID[NUM_ToWriteTagIDBytesMax - m_toWriteTagIDNum]);
					IncreaseToWriteTagID();

					CString nextToWriteTagIDStr;
					GetToWriteTagIDStr(&nextToWriteTagIDStr);
					SetDlgItemText(IDC_EDIT_TAGID, nextToWriteTagIDStr);
				}
				else
					DisplayInNewLine(IDS_MSG_WriteFail);
			}
			else
				DisplayInNewLine(IDS_MSG_WriteFail);
		}
		else
			DisplayInNewLine(IDS_MSG_OldTag);
	}
}

bool CEPCDemoView::WriteTag(bool lock)
{
	bool ret = false;
	for(int i = 0; i <NUM_MaxRetryTimes; i++)
	{
//		if(lock)
//			ret = ::FastWriteTagID_Lock(m_hCom, m_toWriteTagIDNum, &m_toWriteTagID[NUM_ToWriteTagIDBytesMax - m_toWriteTagIDNum]);
//		else
			ret = ::FastWriteTagID	   (m_hCom, m_toWriteTagIDNum, &m_toWriteTagID[NUM_ToWriteTagIDBytesMax - m_toWriteTagIDNum],0);
		if(ret)
			break;
	}
	return ret;
}

bool CEPCDemoView::AuthorizeTag(void)
{
	bool ret = false;
	for(int i = 0; i <NUM_MaxRetryTimes; i++)
	{
		ret = ::AuthorizeTag(m_hCom,0);
		if(ret)
			break;
	}
	return ret;
}

void CEPCDemoView::IncreaseToWriteTagID(void)
{
	// Tag ID +1
	m_toWriteTagID[NUM_ToWriteTagIDBytesMax - 1]++;
	// Improve
	for(int i = NUM_ToWriteTagIDBytesMax - 1; i >= NUM_ToWriteTagIDBytesMax - m_toWriteTagIDNum; i--)
	{
		if(m_toWriteTagID[i] <= 0 && i > 0)
			m_toWriteTagID[i - 1]++;
		else
			break;
	}
	if(m_toWriteTagIDNum <= NUM_ToWriteTagIDBytesMax - 2)
	{
		bool improve = true;
		for(int i = NUM_ToWriteTagIDBytesMax - 1; i >= NUM_ToWriteTagIDBytesMax - m_toWriteTagIDNum; i--)
		{
			if(m_toWriteTagID[i] > 0)
				improve = false;
		}
		if(improve)
			m_toWriteTagIDNum += 2;
	}
}

bool CEPCDemoView::IsNewTag(BYTE tagID[LEN_TagID])
{
	bool ret = false;
	for(int i = 0; i < LEN_TagID; i++)
	{
		if(m_currentTagID[i] != tagID[i])
		{
			ret = true;
			break;
		}
	}
	return ret;
}

void CEPCDemoView::SetCurrentTagID(BYTE tagID[LEN_TagID], BYTE writeBytesNum, BYTE* writeBytes)
{
	for(int i = 0; i < LEN_TagID - writeBytesNum; i++)
		m_currentTagID[i] = tagID[i];
	for(i = 0; i < writeBytesNum; i++)
		m_currentTagID[i + LEN_TagID - writeBytesNum] = writeBytes[i];
}

void CEPCDemoView::GetToWriteTagIDStr(CString* str)
{
	CString byteStr;
	for(int i = NUM_ToWriteTagIDBytesMax - m_toWriteTagIDNum; i < NUM_ToWriteTagIDBytesMax; i++)
	{
		byteStr.Format("%02X ", m_toWriteTagID[i]);
		*str += byteStr;
	}
}

bool CEPCDemoView::IsHexChar(char ch)
{
	if(	ch == 'a' || ch == 'b' || ch == 'c' || ch == 'd' || ch == 'e' || ch == 'f' ||
		ch == 'A' || ch == 'B' || ch == 'C' || ch == 'D' || ch == 'E' || ch == 'F' ||
		ch == '0' || ch == '1' || ch == '2' || ch == '3' || ch == '4' || 
		ch == '5' || ch == '6' || ch == '7' || ch == '8' || ch == '9')
		return true;
	else
		return false;
}

bool CEPCDemoView::StrToHexNums(LPCTSTR str, BYTE* hexBuf, BYTE* len)
{
	CString strHex = str;
	strHex.Remove(' ');		// Remove all Spaces (0x20)
	int strLen = strHex.GetLength();
	if(strLen < 2 || (strLen % 2) != 0 || strLen > ((*len) * 2))
		return false;
	// Check if it is valid hex input
	const char* start = (LPCTSTR)strHex;
	for(int i = 0; i < strLen; i++)
	{
		if(!IsHexChar(*(start + i)))
			return false;
	}
	// Convert every two chars to a BYTE number
	char tmpBuf[3] = {'\0', '\0', '\0'};
	char* endptr = NULL;
	::memset(hexBuf, 0, sizeof(BYTE) * (*len));
	for(int j = 0; j < strLen / 2; j++)
	{
		::memcpy(tmpBuf, start + j * 2, 2);
		BYTE value = (BYTE)::strtol((LPCTSTR)tmpBuf, &endptr, 16);
		hexBuf[j] = value;
	}
	*len = strLen / 2;
	return true;
}
/////////////////////////////////////////////////////////////////////////////
// CEPCDemoView diagnostics

#ifdef _DEBUG
void CEPCDemoView::AssertValid() const
{
	CFormView::AssertValid();
}

void CEPCDemoView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CEPCDemoDoc* CEPCDemoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEPCDemoDoc)));
	return (CEPCDemoDoc*)m_pDocument;
}
#endif //_DEBUG
/////////////////////////////////////////////////////////////////////////////
// CEPCDemoView message handlers
void CEPCDemoView::OnBUTTONConnect() 
{
	CComboBox* comboPortNo = (CComboBox*)GetDlgItem(IDC_COMBO_PortNo);
	int portNo = comboPortNo->GetCurSel() + 1;
	m_hCom = ::OpenComm(portNo);
	if(m_hCom != INVALID_HANDLE_VALUE)
	{
		if(StopReading(m_hCom,0) && StopWorking(m_hCom,0) && ReadFirmwareVersion(m_hCom, &m_verMain, &m_verSub,0))
		{
			SetStatus(STATUS_CommOpen);

			CString strFormat;
			strFormat.LoadString(IDS_MSG_FirmVersion);
			CString strFirmVersion;
			strFirmVersion.Format(strFormat, m_verMain, m_verSub);
			DisplayInNewLine(IDS_MSG_Connect);
			DisplayInNewLine(strFirmVersion);
		}
		else
		{
			CloseComm(m_hCom);
			DisplayInNewLine(IDS_MSG_ConnectDeviceFail);
		}
	}
	else
		DisplayInNewLine(IDS_MSG_OpenCommFail);
}

void CEPCDemoView::OnBUTTONDisconnect() 
{
	SetStatus(STATUS_Init);
	::ResetReader(m_hCom,0);
	::CloseComm(m_hCom);
	m_hCom = INVALID_HANDLE_VALUE;
	DisplayInNewLine(IDS_MSG_Disconnect);
}

void CEPCDemoView::OnBUTTONClear() 
{
	CEdit* display = (CEdit*)GetDlgItem(IDC_EDIT_Display);
	display->SetWindowText("");
}

void CEPCDemoView::OnBUTTONStart() 
{
	CString strWriteTagID;
	GetDlgItemText(IDC_EDIT_TAGID, strWriteTagID);
	BYTE writeTagID[NUM_ToWriteTagIDBytesMax];
	for(int i = 0; i < NUM_ToWriteTagIDBytesMax; i++)
		writeTagID[i] = 0;
	BYTE num = NUM_ToWriteTagIDBytesMax;
	bool trans = CEPCDemoView::StrToHexNums(strWriteTagID, writeTagID, &num);
	if(!trans || num < 2 || num > NUM_ToWriteTagIDBytesMax || (num % 2) != 0/* num != 8*/)
		DisplayInNewLine(IDS_MSG_InvalidInput);
	else
	{
		// Set To Write ID
		m_toWriteTagIDNum = num;
		for(i = 0; i < NUM_ToWriteTagIDBytesMax - num; i++)
			m_toWriteTagID[i] = 0;
		for(int i = NUM_ToWriteTagIDBytesMax - num; i < NUM_ToWriteTagIDBytesMax; i++)
			m_toWriteTagID[i] = writeTagID[i - NUM_ToWriteTagIDBytesMax + num];
		// Start
		SetStatus(STATUS_WrittingTag);
		CComboBox* comboSpeed = (CComboBox*)GetDlgItem(IDC_COMBO_Speed);
		int interval = 1000;
		if(comboSpeed->GetCurSel() == 0)		// Normal
			interval = 1000;
		else if(comboSpeed->GetCurSel() == 1)	// Fast
			interval = 500;
		else if(comboSpeed->GetCurSel() == 2)	// Fastest
			interval = 300;
		else
			interval = 1000;
		SetTimer(TIMER_WrittingTag, interval, NULL);
	}
}

void CEPCDemoView::OnBUTTONStop() 
{
	SetStatus(STATUS_CommOpen);
	KillTimer(TIMER_WrittingTag);
}

void CEPCDemoView::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == TIMER_WrittingTag)
		WriteTagProcess();
	else
		CFormView::OnTimer(nIDEvent);
}

void CEPCDemoView::OnDestroy() 
{
	CFormView::OnDestroy();
	Finalize();
}
